<template>
  <div class="min-h-full bg-bgdsec rounded-32 p-8 sm:p-4 xs:p-4 overflow-hidden">
    <transition name="default-plug">
      <div v-show="loading" class="default-plug absolute inset-0 z-1">
        <div class="flex items-center justify-center w-full h-full"><LoadingSpinner /></div>
      </div>
    </transition>
    <div class="flex items-center justify-between">
      <a v-if="isMainPage" href="https://flashnodes.io/" target="_blank">
        <UiButton colorType="outline" buttonHeight="sm" class="w-12 rounded-16">
          <img width="20" height="15" src="@/assets/images/statistics/back-to-site.svg" />
        </UiButton>
      </a>
      <router-link v-else to="/">
        <UiButton colorType="outline" buttonHeight="sm" class="w-12 rounded-16">
          <img width="24" height="24" src="@/assets/images/statistics/arrow-left.svg" />
        </UiButton>
      </router-link>
      <UiTab :options="options" translate v-model="currentOption" />
    </div>
    <div class="mt-8 sm:mt-4 xs:mt-4 flex items-center xs:flex-col rounded-32 bg-bgdtert">
      <div class="the-statistics__info-block xs:w-full h-20 flex items-center gap-4 p-2">
        <div class="h-full w-16 rounded-24 flex justify-center items-center bg-btndsec">
          <img width="24" height="24" src="@/assets/images/statistics/total-data.svg" />
        </div>
        <div>
          <p class="text-txtdtert text-sm leading-5 font-medium">{{ $t('statistics.total') }}</p>
          <p class="mt-1 text-txtdprim font-bold leading-5">
            {{ this.analytics.total_requests ? this.analytics.total_requests : 0 }}
          </p>
        </div>
      </div>
      <div class="w-0.5 h-20 bg-bgdsec xs:w-full xs:h-0.5"></div>
      <div class="the-statistics__info-block xs:w-full h-20 flex items-center gap-4 p-2">
        <div class="h-full w-16 rounded-24 flex justify-center items-center bg-btndsec">
          <img width="24" height="24" src="@/assets/images/statistics/average-data.svg" />
        </div>
        <div>
          <p class="text-txtdtert text-sm leading-5 font-medium">{{ $t('statistics.average') }}</p>
          <p class="mt-1 text-txtdprim font-bold leading-5">
            {{ this.analytics.average_rps ? this.analytics.average_rps : 0 }}
          </p>
        </div>
      </div>
    </div>
    <TheChart :timerange="currentOption.value" :loading="loading" class="mt-8" />
  </div>
</template>

<script>
import TheChart from '@/components/statistics/TheChart.vue';
import LoadingSpinner from '@/components/ui/LoadingSpinner.vue';
import UiButton from '@/components/ui/UiButton.vue';
import UiTab from '@/components/ui/UiTab.vue';

export default {
  name: 'TheStatistics',

  components: { TheChart, UiButton, UiTab, LoadingSpinner },

  props: {
    loading: {
      type: Boolean,
      default: false,
    },
  },

  data() {
    return {
      options: [
        {
          title: '1h',
          value: '1h',
        },
        {
          title: '1d',
          value: '1d',
        },
        {
          title: '7d',
          value: '7d',
        },
        {
          title: '30d',
          value: '30d',
        },
      ],

      currentOption: {
        title: '1h',
        value: '1h',
      },
    };
  },

  computed: {
    isAuthorized() {
      return this.$store.state.auth.isAuthorized;
    },

    isMainPage() {
      return this.$route.name === 'index';
    },

    analytics() {
      return this.$store.state.auth.analytics;
    },
  },

  watch: {
    currentOption(newVal) {
      this.$emit('update-timerange', newVal);
    },
  },
};
</script>

<style lang="scss">
.the-statistics {
  &__info-block {
    width: calc(50% - 1px);
  }
}

.blur {
  // filter: blur(0.05px);
}
</style>
